<template>
    <help-layout>
        <template #title>Displays</template>
        <p>
            The only requirements for running the Vapor client is Chrome or another chromium-based browser, like Edge.
            It is highly recommended to have something with a touchscreen to get the full interactive experience.
            While video shows only need a minimal processor, shows have a lot of animations need at least a i3 for a smooth experience.
            It is also recommended to find a computer that has an auto-start capability, such as a Dell Optiplex, if it is an all-in-one.
        </p>
        <slide-dropdown class="mt-4" :options="osOptions" color="blue" v-model="os">Operating System</slide-dropdown>
        <fade-transition>
            <div v-if="os==''">
                <p>
                    Please select an operating system from above to get tailored instructions.
                </p>
            </div>
            <div v-else>
                <h2 class="font-bold text-xl mb-2">Setting up a Display</h2>
                <div v-if="os=='windows'">
                    <p class="mb-2">
                        If you are not using a domain-joined Windows computer, you will have to setup auto-login manually.
                    </p>
                    <ol class="list-decimal pl-4">
                        <li class="mb-2">Install Chrome, unless you want to use Edge.</li>
                        <li class="mb-2">Create a new standard user with a username of vapor.</li>
                        <li class="mb-2">On the C:\ drive, create the following reg files:
                            <code-block name="AutoLoginSetup.reg">Windows Registry Editor Version 5.00
[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon]
"AutoAdminLogon"=dword:00000001
"DefaultDomainName"="<span class="italic text-red-800 dark:text-red-600">&lt;COMPUTERNAME&gt;</span>"
"DefaultUserName"="vapor"
"DefaultPassword"="<span class="italic text-red-800 dark:text-red-600">&lt;Vapor Password&gt;</span>"
"ForceAutoLogon"=dword:00000001
"DisableLockWorkstation"=dword:00000001
"EnableFirstLogonAnimation"=dword:00000000</code-block>
                            <code-block name="CurrentUserBrowserShell.reg">Windows Registry Editor Version 5.00
[HKEY_CURRENT_USER\Software\Microsoft\Windows NT\CurrentVersion\Winlogon]
"shell"="\"<span class="italic text-red-800 dark:text-red-600">&lt;path to browser&gt;</span>\" --kiosk"</code-block>
                            <p class="ml-6">
                                Make sure to fill in places with <span class="italic text-red-800 dark:text-red-600">&lt;placeholders&gt;</span> with the appropriate value, escaping any backslashes or other special characters with backslashes.
                            </p>
                        </li>
                        <li class="mb-2">
                            You will need to setup a few Chrome policies to ensure that you have a smooth experience.
                            We will setup the policies just like if you were domain-joined via local group policy (gpedit.msc).
                            Download the google/chrome admx policies and place them in <ch>C:\Windows\PolicyDefinitions</ch>.
                            After that, please see the Chrome settings in the Group policy section to see what to setup
                            (Computer\Policies\Administrative Templates\Google\Google Chrome).
                        </li>
                        <li class="mb-2">Double-click on the AutoLoginSetup.reg and run it to setup the auto-login.</li>
                        <li class="mb-2">Logout and login as vapor (should be automatic now)</li>
                        <li class="mb-2">
                            Open Chrome for the first time.
                            Since we are not using group policy
                        </li>
                        <li>Double-click on the <ch>CurrentUserBrowserShell.reg</ch> file to setup the kiosk mode.</li>
                    </ol>
                </div>
                <div v-if="os=='gpo'">
                    <p class="mb-2">
                        Using group policy is one of the easiest ways to deploy screens.
                    </p>
                    <h3 class="font-semibold font-lg mb-2">AD Setup</h3>
                    <p>
                        Before deploying to a computer, you must have a user, OU, and GPO setup.
                        Depending your structure, you may need to adjust the instructions as you see fit.
                        Please make sure the Google Chrome group policy templates have been added to your domain policy.
                    </p>
                    <ol class="list-decimal pl-4">
                        <li class="mb-2">Create an OU that the computers and vapor user will go into.</li>
                        <li class="mb-2">Create a user that will login to the computer in the OU above.</li>
                        <li class="mb-2"><span class="font-semibold">Filtering:</span> If you are using an internet filter or proxy, make sure that the user can get to vaporclient.churchtech.help and any other site that may be shown.</li>
                        <li class="mb-2">In Group Policy Management, create a new group policy object in the OU created in step 1.
                            <ul class="list-disc pl-6">
                                <li class="mb-2">Optional/Buggy: Deploy the Google Chrome Standalone installer using Assigned Applications.</li>
                                <li class="mb-2">Computer\Policies\Windows Settings\Security Settings\Local Policies\User Rights Assignment\Interactive logon: Do not require CTRL+ALT+DEL = Enabled</li>
                                <li class="mb-2">Computer\Policies\Administrative Templates\Control Panel\Personalization\Do not display the lock screen = Enabled</li>
                                <li class="mb-2">Computer\Policies\Administrative Templates\Google\Google Chrome 
                                    <ul class="list-disc pl-6">
                                        <li class="mb-2">Allow Dinosour Easter Egg Game = Disabled</li>
                                        <li class="mb-2">Allow media autoplay = Enabled</li>
                                        <li class="mb-2">Allow or deny audio capture = Enabled</li>
                                        <li class="mb-2">Allow or deny video capture = Enabled</li>
                                        <li class="mb-2">Allow proceeding from the SSL warning page = Enabled</li>
                                        <li class="mb-2">Always open PDF files externally = Disabled</li>
                                        <li class="mb-2">Set Google Chrome as Default Browser = Disabled</li>
                                        <li class="mb-2">Default search provider\Enable default search provider = Disabled</li>
                                        <li class="mb-2">Password manager\Enable saving passwords to the password manager = Disabled</li>
                                        <li class="mb-2">Printing\Disable print preview = Enabled</li>
                                        <li class="mb-2">Printing\Enable Printing = Disabled</li>
                                        <li class="mb-2">Proxy server = Set these as needed</li>
                                        <li class="mb-2">Startup/Home page and New Tab page/Action on Startup = Open a list of url's</li>
                                        <li class="mb-2">Startup/Home page and New Tab page/Configure the home page url = <ch>https://vaporclient.churchtech.help</ch></li>
                                        <li class="mb-2">Startup/Home page and New Tab page/URLs to open on startup = <ch>https://vaporclient.churchtech.help</ch></li>
                                        <li>Startup/Home page and New Tab page/Use New tab page as enabled = Disabled</li>
                                    </ul>
                                </li>
                                <li class="mb-2">Computer\Policies\Administrative Templates\System\Logon\Hide entry points for Fast User Switching = Enabled</li>
                                <li class="mb-2">Computer\Policies\Administrative Templates\System\Logon\SHow first sign-in animation = Disabled</li>
                                <li class="mb-2">Computer\Policies\Administrative Templates\System\Sleep Settings\Turn off hybrid sleep (BOTH) = Enabled</li>
                                <li class="mb-2">
                                    Computer\Preferences\Windows Settings\Files: Create a new file at C:\Vapor\shell.vbs. Point to somewhere accessible on the domain, like NETLOGON
                                    <code-block name='C:\Vapor\shell.vbs'>strComputer = "."

Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2:Win32_Process")
Set fso = CreateObject("Scripting.FileSystemObject")

If fso.FileExists("C:\Program Files\Google\Chrome\Application\chrome.exe") Then
	errResult = objWMIService.Create("C:\Program Files\Google\Chrome\Application\chrome.exe --kiosk http://vaporclient.churchtech.help", "C:\Program Files\Google\Chrome\Application\", null, intPosID)
Else
	errResult = objWMIService.Create("C:\Program Files (x86)\Google\Chrome\Application\chrome.exe --kiosk http://vaporclient.churchtech.help", "C:\Program Files (x86)\Google\Chrome\Application\", null, intPosID)
End If

Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

Set colProcesses = objWMIService.ExecNotificationQuery _
	("Select * From __InstanceDeletionEvent " _ 
			& "Within 1 Where TargetInstance ISA 'Win32_Process'")

Do Until False = True
	Set objProcess = colProcesses.NextEvent
	If objProcess.TargetInstance.ProcessID = intPosID Then
		Exit Do
	End If
Loop

Set oSystems = GetObject("winmgmts:{(Shutdown)}//./root/cimv2").ExecQuery("select * from Win32_OperatingSystem where Primary=true")
For Each oSystem in oSystems
   'LOGOFF   = 0
   'SHUTDOWN = 1
   'REBOOT   = 2
   'FORCE    = 4
   'POWEROFF = 8
   oSystem.Win32Shutdown 0
Next</code-block>
                                </li>
                                <li class="mb-2">TODO: Auto login (SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon\AutoAdminLogon,DefaultUserName,DefaultPassword,ForceAutoLogon,AutoLogonSID,DefaultDomainName,[-AutoLoginCount]</li>
                                <li>User\Policies\Administrative Templates\System\Custom User Interface = <ch>cscript c:\Vapor\shell.vbs</ch></li>
                            </ul>
                        </li>
                    </ol>
                </div>
                <div v-if="os=='macos'">
                    <p class="mb-2">
                        MacOS instructions have not been made or tested yet.
                    </p>
                    <p class="mb-2">
                        For now, just go to <a href="https://vaporclient.churchtech.help" class="dark:text-indigo-300">https://vaporclient.churchtech.help</a> in Chrome (not Safari). Then press F11 to go full-screen.
                    </p>
                    <p>
                        To run automatically, you will need a bash file which you will mark as executable.
                        <code-block name="chromeKiosk.sh">#!/bin/bash
/Applications/Google\ Chrome.app/Contents/MacOS/Google\ Chrome --kiosk --app=https://vaporclient.churchtech.help</code-block>
                    </p>
                </div>
                <div v-if="os=='mobile'">
                    <ol class="list-decimal pl-4">
                        <li class="mb-2">Go to <a href="https://vaporclient.churchtech.help">https://vaporclient.churchtech.help</a> in Chrome. Please do not open in Safari.</li>
                        <li class="mb-2">Accept the prompt to store files on your device</li>
                        <li class="mb-2">You should be asked if you want to install it. Click on the install button to install. The client will not work offline otherwise.</li>
                        <li>Register your mobile display</li>
                    </ol>
                </div>
                <div v-if="os=='ubuntu'">
                    <ol class="list-decimal pl-4">
                        <li class="mb-2">Install the latest desktop LTS version of Ubuntu. Use the minimal install with third-party codecs.</li>
                        <li class="mb-2">Update all packages</li>
                        <li class="mb-2">Go to Google and download the .deb file and install Chrome</li>
                        <li class="mb-2">Create a standard user with the username vapor</li>
                        <li class="mb-2">
                            Untested - uses x server, not Wayland. Setup a kiosk X session file:
                            <div class="block italic ml-6 mt-2">/usr/share/xsessions/kiosk.desktop</div>
                                <code-block>[Desktop Entry]
Encoding=UTF-8
Name=Kiosk Mode
Comment=Chrome Kiosk Mode
Exec=/usr/bin/google-chrome --kiosk https://vaporclient.churchtech.help
Type=Application</code-block>
                        </li>
                        <li class="mb-2">In the user control panel, set the vapor user to auto login and set the default session to Kiosk Mode</li>
                        <li>Make sure the first time it runs to accept the storage prompt</li>
                    </ol>
                </div>
                <div v-if="os=='rpi'">
                    <p>
                        Raspberry Pi instructions have not yet been made. We want to do an image for easy setup. Setup should be very similar to Ubuntu.
                    </p>
                </div>
                <h2 class="font-bold text-xl mt-4 mb-2">Registering a Display</h2>
                <p>
                    Registering a display is easy.
                    First, just get the code on the bottom right of the display. If you can remote into the device, you can click on it to copy it.
                    Second, go to the displays section in Vapor and click on new display. Paste or type in the display's code and a good name.
                    Please note, if you want the display to be a part of an organization, please make sure to select your organization from your
                    user logo on the top-right first.
                </p>
            </div>
        </fade-transition>
    </help-layout>
</template>

<script>
    import HelpLayout from './../../Layouts/HelpLayout'
    import FadeTransition from '../../Components/FadeTransition'
    import CodeBlock from '../../Components/CodeBlock'
    import CodeHighlight from '../../Components/CodeHighlight'

    export default {
        components: {
            HelpLayout,
            FadeTransition,
            CodeBlock,
            ch: CodeHighlight,
        },
        data() {
            return {
                osOptions: [
                    {
                        value: 'windows',
                        label: 'Windows',
                        fontawesome: ['fab','windows'],
                    },
                    {
                        value: 'gpo',
                        label: "Group Policy",
                        fontawesome: ['fab','windows'],
                    },
                    {
                        value: 'macos',
                        label: "MacOS",
                        fontawesome: ['fab','apple'],
                    },
                    {
                        value: 'mobile',
                        label: "Mobile (Android/iOS,iPadOS)",
                        fontawesome: 'tablet-alt',
                    },
                    {
                        value: 'ubuntu',
                        label: "Ubuntu",
                        fontawesome: ['fab','ubuntu'],
                    },
                    {
                        value: 'rpi',
                        label: "Raspberry Pi",
                        fontawesome: ['fab','raspberry-pi'],
                    },
                ],
                os: '',
            }
        }
    }
</script>